# -*- coding: utf-8 -*-

import json
import requests

from . import crypto
from .exceptions import AppNotFoundError, ImageNotFoundError

TYPE_APP = 'apps'
TYPE_IMAGE = 'images'

def load():
    raise NotImplementedError()

def get_entries(entry_type):
    data = load()
    return data[entry_type]

def get_entry(entry_type, name):
    return get_entries(entry_type)[name]

def get_images():
    return get_entries(TYPE_IMAGE)

def get_image(image_name):
    try:
        return get_entry(TYPE_IMAGE, image_name)
    except KeyError as e:
        raise ImageNotFoundError(image_name) from e

def get_apps():
    return get_entries(TYPE_APP)

def get_app(app_name):
    try:
        return get_entry(TYPE_APP, image_name)
    except KeyError as e:
        raise ImageNotFoundError(image_name) from e
